<?php
/*
Название: Obnulator
Описание: скрипт обнуления (установки) паролей пользователей для популярных PHP проектов: WordPress 2.x, WordPress MU, phpBB2, phpBB3, Joomla
Версия: 1.1
Автор: Denis Bri aka handyblogger ( handyblogger[At]gmail.com )
Сайт:: http://handynotes.ru
*/

$obnulator['username'] = 'admin';
$obnulator['password'] = '12345678';

$obnulator['title'] = 'Изменение пароля пользователя для %s версии %s';
$obnulator['cms'] = array(1 => 'WordPress', 2 => 'phpBB', 3 => 'Joomla');

$obnulator['errEmptyUser'] = 'Имя пользователя не может быть пустым.<br />';
$obnulator['errEmptyPass'] = 'Пароль не может быть пустым.<br />';
$obnulator['errUserNotExist'] = 'Пользователь \'%s\' не существует.<br />';
$obnulator['errUnspec'] = 'Неопознанная ошибка, пароль не изменен.<br />';
$obnulator['errVersion'] = 'Скрипт не работает для этой версии %s.<br />';
$obnulator['errEnv'] = 'Упс! Скрипт не смог определить, с каким из следующих проектов он будет работать:<br /> WordPress 2.x, WordPress MU, phpBB2, phpBB3 или Joomla.<br /><br />Возможные причины: <ul><li>Вы скопировали данный скрипт не в "корень" какого-либо из перечисленных проектов</li><li>Это более новая версия одного из перечисленных проектов, либо совершенно новый проект, который не входит в список вышеназванных. Если Вы хотите, что-бы данный скрипт поддерживал работу с новым проектом или у Вас есть какие-то вопросы или пожелания -<br />отправьте запрос на handyblogger[At]gmail.com и возможно Вам помогут</li></ul>';

$obnulator['succMessage'] = 'Пароль успешно изменен.<br /><h1>Внимание!!! Не забудьте удалить этот скрипт.</h1>';
$obnulator['showForm'] = true;
$obnulator['message'] = '';

if (isset($_REQUEST['btn'])) {
	if (isset($_REQUEST['user'])) {
		$obnulator['username'] = trim($_REQUEST['user']);
		if ($obnulator['username'] === '') $obnulator['message'] .= $obnulator['errEmptyUser'];
	}
	if (isset($_REQUEST['pass'])) {
		$obnulator['password'] = $_REQUEST['pass'];
		if ($obnulator['password'] === '') $obnulator['message'] .= $obnulator['errEmptyPass'];
	}
}

if ($obnulator['message'] === '') {
	switch (lookingAround()) {

		/* WordPress, WordPress MU */
			
		case 1 :
	
			define('WP_ADMIN', TRUE);
			require_once('./wp-config.php');
			
			if (isset($wpmu_version)) $obnulator['cms'][1] .= ' MU';
			$tmp = explode('.', $wp_version);
			$obnulator['title'] = sprintf($obnulator['title'], $obnulator['cms'][1], $wp_version);
			
			if ($tmp[0] == 2) {
	
				if ($tmp[1] < 3 ) {
					require_once('./wp-admin/admin.php');
				} else {
					require_once('./wp-admin/includes/admin.php');
				}
		
				if (isset($_REQUEST['btn'])) {
					
					$user =	get_userdatabylogin($obnulator['username']);
					if ($user === false) {
						$obnulator['message'] = sprintf($obnulator['errUserNotExist'], $obnulator['username']);
					} else {
						if ($res = wp_update_user(array("ID" => $user->ID, "user_pass" => $obnulator['password']))) {
							$obnulator['message'] = $obnulator['succMessage'];
						} else $obnulator['message'] = $obnulator['errUnspec'];
					}
				}
			} else {
				$obnulator['message'] = sprintf($obnulator['errVersion'], $obnulator['cms'][1]);
			}
			
			break;
			
		/* phpBB */

		case 2 :

			define('IN_PHPBB', true);
			$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
			$phpEx = substr(strrchr(__FILE__, '.'), 1);

			if (file_exists($phpbb_root_path . 'extension.inc') !== false) {
				include($phpbb_root_path . 'extension.inc');
				include($phpbb_root_path . 'common.'.$phpEx);
				require($phpbb_root_path . 'includes/functions_validate.'.$phpEx);
			} else {
				include($phpbb_root_path . 'common.' . $phpEx);
				include($phpbb_root_path . 'includes/functions_user.' . $phpEx);
			}

			if (!isset($config['version'])) $config['version'] = '2' . $board_config['version']; 
			$obnulator['title'] = sprintf($obnulator['title'], $obnulator['cms'][2], $config['version']);
			
			if (isset($_REQUEST['btn'])) {
			
				$tmp = explode('.', $config['version']);

				if ($tmp[0] == 2) {

					$result = validate_username($obnulator['username']);
					if ($result['error'] && $result['error_msg'] == $lang['Username_taken']) {
					
						$hash = md5($obnulator['password']);
						$row = get_userdata($obnulator['username']);
						
						$db->sql_query('UPDATE ' . USERS_TABLE . ' SET user_password = "' . $hash . '" WHERE user_id = ' . $row['user_id']);
				
				    $sql = 'SELECT user_password
				      FROM ' . USERS_TABLE . '
				      WHERE user_id = ' . $row['user_id'];
				    $result = $db->sql_query($sql);
				    $row = $db->sql_fetchrow($result);
				    $db->sql_freeresult($result);
				    
				    if ($row['user_password'] == $hash) {
				    	$obnulator['message'] = $obnulator['succMessage'];
				    } else {
				    	$obnulator['message'] = $obnulator['errUnspec'];
				    }
					} else {		
						$obnulator['message'] = sprintf($obnulator['errUserNotExist'], $obnulator['username']);
					}
				
				} elseif ($tmp[0] == 3) {
				
					if (validate_username($obnulator['username']) === 'USERNAME_TAKEN') {		
						
						$hash = phpbb_hash($obnulator['password']);
						
						$user_arr = array($obnulator['username']);
						$user_id = array();
						user_get_id_name($user_id, $user_arr);
				
				    $sql_ary = array(
				      'user_password'   => $hash,
				    );
				    $sql = 'UPDATE ' . USERS_TABLE . '
				      SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
				      WHERE user_id = ' . $user_id[0];
				    $db->sql_query($sql);
						
				    $sql = 'SELECT user_password
				      FROM ' . USERS_TABLE . '
				      WHERE user_id = ' . $user_id[0];
				    $result = $db->sql_query($sql);
				    $row = $db->sql_fetchrow($result);
				    $db->sql_freeresult($result);
				    
				    if ($row['user_password'] == $hash) {
				    	$obnulator['message'] = $obnulator['succMessage'];
				    } else {
				    	$obnulator['message'] = $obnulator['errUnspec'];
				    }
					} else {
						$obnulator['message'] = sprintf($obnulator['errUserNotExist'], $obnulator['username']);
					}
				
				} else {
					$obnulator['message'] = sprintf($obnulator['errVersion'], $obnulator['cms'][2]);
				}
			}
			
			break;
			
		/* Joomla */

		case 3 :
		
			if (is_file('./includes/version.php') === true) {
				define('_VALID_MOS', 1);
				
				saveGLOBALS();

				require( 'globals.php' );
				require( 'configuration.php' );
				require_once( 'includes/joomla.php' );
				$config['version'] = $_VERSION->RELEASE .'.'. $_VERSION->DEV_LEVEL;
				
				restoreGLOBALS();
				
			} else {
			
				saveGLOBALS();
				
				define( '_JEXEC', 1 );
				define( 'JPATH_BASE', dirname(__FILE__) );
				define( 'DS', DIRECTORY_SEPARATOR );
				require_once ( JPATH_BASE .DS.'includes'.DS.'defines.php' );
				require_once ( JPATH_BASE .DS.'includes'.DS.'framework.php' );

				restoreGLOBALS();
				
				$config['version'] = JVERSION;
			}	

			$obnulator['title'] = sprintf($obnulator['title'], $obnulator['cms'][3], $config['version']);
			
			if (isset($_REQUEST['btn'])) {
			
				$tmp = explode('.', $config['version']);

				if ($tmp[1] == 0) {
				
					$query = "SELECT id  FROM #__users WHERE username = " . $database->Quote( $obnulator['username'] );
					$database->setQuery( $query );
					$id = $database->loadResult();
					
					if ($id !== null) {
					
						$query = 'UPDATE #__users ' .
							'SET password = ' . $database->Quote(md5($obnulator['password'])) . ' ' .
							'WHERE id = ' . (int)$id;
						$database->setQuery($query);
						if (!$database->query()) {
				    	$obnulator['message'] = $obnulator['errUnspec'];
				    } else {
				    	$obnulator['message'] = $obnulator['succMessage'];
				    }
					
					} else {
						$obnulator['message'] = sprintf($obnulator['errUserNotExist'], $obnulator['username']);
					}

				} elseif ($tmp[1] == 5) {

					$mainframe =& JFactory::getApplication('site');

					jimport('joomla.user.helper');
					$id = JUserHelper::getUserId($obnulator['username']);

					if ($id !== null) {

						$db = &JFactory::getDBO();
						$salt = JUserHelper::genRandomPassword(32);
						$crypt = JUserHelper::getCryptedPassword($obnulator['password'], $salt);
						$password	= $crypt.':'.$salt;
						
						$query 	= 'UPDATE #__users'
								. ' SET password = '.$db->Quote($password)
								. ' WHERE id = '.(int) $id;
						$db->setQuery($query);
						
						if (!$db->query()) {
				    	$obnulator['message'] = $obnulator['errUnspec'];
						} else {
				    	$obnulator['message'] = $obnulator['succMessage'];
						}
						
					} else {
						$obnulator['message'] = sprintf($obnulator['errUserNotExist'], $obnulator['username']);
					}
					

				} else {
					$obnulator['message'] = sprintf($obnulator['errVersion'], $obnulator['cms'][3]);
				}
			}
			
			break;
			
		/* unknown */

		default:
			$obnulator['title'] = sprintf($obnulator['title'], 'unknown', 'unknown');
			$obnulator['message'] = $obnulator['errEnv'];
			break;
			
	}
}

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns='http://www.w3.org/1999/xhtml' dir="ltr" lang="en-US">
<head>
<meta content='text/html; charset=UTF-8' http-equiv='Content-Type'/>
<title><?php echo $obnulator['title']; ?></title>
<style type="text/css">
body{text-align:center;}.sign{font-size:90%;text-align:right;color:#777;}.sign a{color:#777;}form{margin:20px 0;}
</style>
</head>
<body>
<?php if ($obnulator['message'] === '') { ?>
<h1><?php echo $obnulator['title'];?></h1>
<form action="" method="post">
Пользователь: <input name="user" value="<?php echo $obnulator['username'] ?>" /> Пароль: <input name="pass" value="<?php echo $obnulator['password'] ?>" /> 
<input type="submit" value="Изменить" name="btn" />
</form>
<?php }
echo $obnulator['message']; ?>
<hr />
<div class="sign">Автор &laquo;<a href="http://handynotes.ru">handyblogger</a>&raquo;</div>
</body>
</html>

<?php

/* 0 - unknown, 1 - WP, 2 - phpBB, 3 - Joomla */
function lookingAround() {
	
	if (is_file('./wp-config.php') === true) {
		return 1;
	} elseif (is_file('./config.php') === true) {
	
		if ($fh = fopen('./config.php', 'r')) {
			do {
				$row = fgets($fh);
				if (strpos($row, 'define(\'PHPBB_INSTALLED\', true)') !== false) {
					fclose($fh);
					return 2;
				}
			} while (!feof($fh));
			fclose($fh);
		}
	} elseif (is_file('./configuration.php') === true && is_file('./includes/joomla.php') === true) {
			return 3;
	}
	
	return 0;
}

function saveGLOBALS() {
	$_REQUEST['obnulator'] = $GLOBALS['obnulator'];
}
function restoreGLOBALS() {
	$GLOBALS['obnulator'] = $_REQUEST['obnulator'];
	unset($_REQUEST['obnulator']);
}
?>
